// trieda pre pracu s OpenGL kamerou
class COGLcamera {
public:
 COGLcamera();          // konstruktor
 virtual ~COGLcamera(); // destruktor

 // inicializacia kamery a OpenGL kresliacej plochy
 void cam_init(GLfloat w,GLfloat h);
 // aktualizacia nastaveni kamery
 void cam_update(void);
 // posun kamery
 void cam_move(void);
 // rotacia kamery
 void cam_rotate(GLfloat x,GLfloat y,GLfloat z);
 // reset pohladu kamery
 void cam_reset(int init_bit);

 GLfloat matrix[16];                             // matica kamery
 GLfloat posx,posy,posz,movx,movy,movz;          // poloha, posun
 // indikatory pre vykonavanie definovanych posunov kamery
 GLubyte goForward,goBack,goUp,goDown,goRight,goLeft,goFast;

 GLfloat ogl_fps; // pocitadlo FPS (snimky za sekundu)

 GLfloat scr_w,scr_h; // sirka, vyska okna
private:
 GLfloat angx,angy,angz,rotx,roty,rotz;          // otocenie, rotacia
 GLfloat oldx,oldy,oldz,targetx,targety,targetz; // povodna poloha, smer
 GLfloat speed,slide,alt,acceleration;           // rychlost, bocny pohyb, zmena vysky, zrychlenie
 GLfloat falldown;                               // pad
 GLubyte movetype;                               // typ pohybu
 GLfloat viewdist;                               // maximalny dohlad
 GLfloat FOV;                                    // uhol pohladu

 GLfloat rotx_factor,roty_factor,rotz_factor;    // konstanty pre upravu rychlosti rotacie
 GLfloat movx_factor,movy_factor,movz_factor;    // konstanty pre upravu rychlosti posunu

 GLuint t_a,t_b; // pomocne premenne

 // ulozenie stareho a noveho casoveho okamihu (ms)
 GLuint oldTime,actTime;
 // cas vykreslenia sceny
 GLfloat difTime;
 GLfloat ogl_frames; // pocitadlo pre FPS (pocet snimkov)
};

